<script setup lang="ts">
  import { getSmallestThumbnailUrl } from '@shopware-pwa/helpers-next';
  import { useDebounceFn } from '@vueuse/core';
  import { LineItem } from '@shopware-pwa/types';
  import { formatProductOptions } from '~/helpers/formatProductOptions';

  const props = defineProps<{
    data: LineItem;
    readonly?: boolean;
    isPromoteCode?: boolean;
  }>();

  const loading = ref(false);
  const lineItem = computed(() => props.data);

  const { removeItem, itemTotalPrice, itemQuantity, changeItemQuantity } = useCartItem(lineItem);

  const itemQuantityAlias = ref(itemQuantity.value);
  syncRefs(itemQuantity, itemQuantityAlias);

  const handleRemove = async () => {
    try {
      loading.value = true;
      await removeItem();
    } finally {
      loading.value = false;
    }
  };

  const dataCard = computed(() => ({
    name: lineItem.value.label,
    price: itemTotalPrice.value,
    image: getSmallestThumbnailUrl(lineItem.value.cover) || lineItem.value?.cover?.url || '',
    options: formatProductOptions(
      lineItem.value.payload?.options?.map((option) => ({
        group: option.group,
        name: option.option,
      })),
    ),
  }));

  const minPurchase = computed(() => lineItem.value.quantityInformation?.minPurchase ?? 1);
  const maxPurchase = computed(() => lineItem.value.quantityInformation?.maxPurchase ?? undefined);
  const purchaseSteps = computed(() => lineItem.value.quantityInformation?.purchaseSteps ?? 1);

  const handleChangeQuantity = (v: number) => {
    if (props.readonly) return;
    itemQuantityAlias.value = v;
    debounceChangeItemQuantity(v);
  };

  const debounceChangeItemQuantity = useDebounceFn((v: number) => {
    changeItemQuantity(v);
  }, 500);
</script>

<template>
  <SwInlineProductCard
    :data="dataCard"
    :loading="loading"
    :readonly="readonly"
    @click="handleClick"
    @remove="handleRemove"
  >
    <template v-if="isPromoteCode" #product-image>
      <div
        class="border-border-default flex h-20 w-20 shrink-0 grow-0 items-center overflow-hidden rounded-md border"
      >
        <span class="i-sw-custom:promote-code text-(3xl/none emerald-900) mx-auto p-0" />
      </div>
    </template>
    <template #product-meta>
      <template v-if="!isPromoteCode">
        <SwQuantitySelector
          :readonly="readonly"
          :model-value="itemQuantityAlias"
          :min-purchase="minPurchase"
          :max-purchase="maxPurchase"
          :purchase-steps="purchaseSteps"
          @update:model-value="handleChangeQuantity"
        />
      </template>
    </template>
  </SwInlineProductCard>
</template>
